package com.nsgk.ruralWeb;

import android.annotation.SuppressLint;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.webkit.WebResourceRequest;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.EditText;

import androidx.annotation.Nullable;
import androidx.appcompat.app.AlertDialog;
import androidx.appcompat.app.AppCompatActivity;


/**
 * An example full-screen activity that shows and hides the system UI (i.e.
 * status bar and navigation/system bar) with user interaction.
 */
public class FullscreenActivity extends AppCompatActivity {

    private WebView mWebView;

    private SensorManagerHelper sensorManagerHelper;

    private BaseWebChromeClient chromeClient;

    @SuppressLint("SetJavaScriptEnabled")
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_fullscreen);
        mWebView = findViewById(R.id.mWebView);
        WebSettings settings = mWebView.getSettings();
        settings.setJavaScriptEnabled(true);

        this.setWebSettings(mWebView);

        mWebView.setWebViewClient(new WebViewClient() {
            @Override
            public boolean shouldOverrideUrlLoading(WebView view, WebResourceRequest request) {
                return false;
            }
        });
        EditText textView = new EditText(this);

        AlertDialog alertDialog = new AlertDialog.Builder(this)
                .setView(textView)
                .setTitle("修改地址")
                .setPositiveButton("确定", (dialogInterface, i) -> mWebView.loadUrl("http://" + textView.getText().toString()))
                .create();

        mWebView.loadUrl("http://116.255.135.38:89/homestead/login");
        chromeClient = new BaseWebChromeClient(this);
        mWebView.setWebChromeClient(chromeClient);

        sensorManagerHelper = new SensorManagerHelper(this);
        sensorManagerHelper.setOnShakeListener(alertDialog::show);
    }

    @Override
    public boolean onKeyDown(int keyCode, KeyEvent event) {
        if (keyCode == KeyEvent.KEYCODE_BACK && mWebView.canGoBack()) {
            mWebView.goBack();
            return true;
        }
        return super.onKeyDown(keyCode, event);
    }

    public void setWebSettings(WebView mView) {
        WebSettings setting = mView.getSettings();
        //支持Js
        setting.setJavaScriptEnabled(true);
        setting.setJavaScriptCanOpenWindowsAutomatically(true);
        //缓存模式
        setting.setCacheMode(WebSettings.LOAD_DEFAULT);
        //支持内容重新布局
        setting.setLayoutAlgorithm(WebSettings.LayoutAlgorithm.SINGLE_COLUMN);
        //将图片调整到适合webview的大小
        setting.setUseWideViewPort(true);
        setting.setLoadWithOverviewMode(true);
        //设置可以访问文件
        setting.setAllowFileAccess(true);
        //支持自动加载图片
        setting.setLoadsImagesAutomatically(true);
        try {
            setting.setMixedContentMode(WebSettings.MIXED_CONTENT_ALWAYS_ALLOW);
        } catch (NoSuchMethodError e) {
            e.printStackTrace();
        }
    }

    @Override
    protected void onActivityResult(int requestCode, int resultCode, @Nullable Intent data) {
        chromeClient.onActivityResult(requestCode, resultCode, data);
        super.onActivityResult(requestCode, resultCode, data);
    }
}